using Syncfusion.Grouping;
using Syncfusion.Windows.Forms;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;
using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace DataGrid
{
    public partial class Form1 : Form
    {     
        public Form1()
        {
            InitializeComponent();

            #region DATASOURCE
            DataTable dt = new DataTable();
            dt.Columns.Add("Column1",typeof(string));
            dt.Columns.Add("Column2", typeof(bool));
            dt.Columns.Add("Column3", typeof(string));
            dt.Columns.Add("Column4", typeof(string));
            dt.Columns.Add("Column5", typeof(string));

            Random r = new Random(123421);
            for (int row = 0; row < 20; row++)
            {
                DataRow dr = dt.NewRow();
                dr[0] = "row" + (row + 1) + "col1";
                dr[1] = false;
                dr[2] = "row" + (row + 1) + "col3";
                dr[3] = "row" + (row + 1) + "col4";
                dr[4] = "row" + (row + 1) + "col5";
                dt.Rows.Add(dr);
            }
            #endregion
            this.gridGroupingControl1.DataSource = dt;
            this.gridGroupingControl1.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
            //To select multiple rows
            this.gridGroupingControl1.TableOptions.ListBoxSelectionMode = SelectionMode.MultiSimple;

            //Invoke the events to select the rows based on the checkbox value
            this.gridGroupingControl1.TableControlCheckBoxClick += new GridTableControlCellClickEventHandler(gridGroupingControl1_TableControlCheckBoxClick);
            this.gridGroupingControl1.TableControlCurrentCellKeyDown += gridGroupingControl1_TableControlCurrentCellKeyDown;
        }

        #region Event Handlers
        void gridGroupingControl1_TableControlCurrentCellKeyDown(object sender, GridTableControlKeyEventArgs e)
        {
            GridStyleInfo style= e.TableControl.CurrentCell.Renderer.CurrentStyle;
           
            if(e.Inner.KeyCode== Keys.Space && style.CellType == GridCellTypeName.CheckBox )
            {
                //Raise the checkbox click event while changing the checkbox value using the space bar
                e.TableControl.RaiseCheckBoxClick(e.TableControl.CurrentCell.RowIndex, e.TableControl.CurrentCell.ColIndex,MouseEventArgs.Empty as MouseEventArgs );
                
            }

        }
        void gridGroupingControl1_TableControlCheckBoxClick(object sender, GridTableControlCellClickEventArgs e)
        {
            GridTableCellStyleInfo style = (GridTableCellStyleInfo)e.TableControl.GetTableViewStyleInfo(e.Inner.RowIndex, e.Inner.ColIndex);
            Record currentRecord = style.TableCellIdentity.DisplayElement.GetRecord();
            //To select the current Row
            currentRecord.SetSelected(style.Text == "False");
        }
        #endregion
    }
}
